// ignore_for_file: non_constant_identifier_names
part of 'google_map_view.widget.dart';

mixin _Community on _Holder {
  /// 获取当前位置
  @override
  Future<LatLng> getLocation({
    Duration interval = const Duration(milliseconds: 500),
    Duration timeout = const Duration(seconds: 10),
  }) async {
    return platform(
      android: (pool) async {
        return Stream.periodic(interval, (_) => _)
            .asyncMap(
              (count) async {
                await (await androidMap).setMyLocationEnabled(true);
                final coord = await (await androidMap).getMyLocation();

                if (coord == null) {
                  return null;
                } else {
                  return LatLng(await coord.latitude, await coord.longitude);
                }
              },
            )
            .take(timeout.inMilliseconds ~/ interval.inMilliseconds)
            .firstWhere((location) => location != null)
            .timeout(timeout, onTimeout: () => null);
      },
      ios: (pool) {
        // TODO 待真机测试, 模拟器无法获取
        return Stream.periodic(interval, (_) => _)
            .asyncMap(
              (count) async {
                await iosController.set_myLocationEnabled(true);
                final location = await iosController.get_myLocation();
                final coord = await location.coordinate;

                if (coord == null) {
                  return null;
                } else {
                  return LatLng(await coord.latitude, await coord.longitude);
                }
              },
            )
            .take(timeout.inMilliseconds ~/ interval.inMilliseconds)
            .firstWhere((location) => location != null)
            .timeout(timeout, onTimeout: () => null);
      },
    );
  }

  // /// 显示我的位置
  // ///
  // /// 可配置的参数详见[MyLocationOption]
  // Future<void> showMyLocation(MyLocationOption option) async {
  //   assert(option != null);
  //   await platform(
  //     android: (pool) async {
  //       final map = await androidController.getMap();
  //       final locationStyle =
  //           await com_google_android_gms_maps_MyLocationStyle.create__();
  //       await locationStyle.showMyLocation(option.show);
  //       await map.setMyLocationEnabled(option.show);
  //
  //       if (option.show) {
  //         switch (option.myLocationType) {
  //           case MyLocationType.Show:
  //             await locationStyle.myLocationType(
  //               com_amap_api_maps_model_MyLocationStyle.LOCATION_TYPE_SHOW,
  //             );
  //             break;
  //           case MyLocationType.Locate:
  //             await locationStyle.myLocationType(
  //               com_amap_api_maps_model_MyLocationStyle.LOCATION_TYPE_LOCATE,
  //             );
  //             break;
  //           case MyLocationType.Follow:
  //             await locationStyle.myLocationType(
  //               com_amap_api_maps_model_MyLocationStyle.LOCATION_TYPE_FOLLOW,
  //             );
  //             break;
  //           case MyLocationType.Rotate:
  //             await locationStyle.myLocationType(
  //               com_amap_api_maps_model_MyLocationStyle
  //                   .LOCATION_TYPE_LOCATION_ROTATE,
  //             );
  //             break;
  //         }
  //         // 定位间隔
  //         await locationStyle.interval(option.interval.inMilliseconds);
  //
  //         // 定位图标
  //         if (option.iconProvider != null) {
  //           final imageData = await option.iconProvider
  //               .toImageData(createLocalImageConfiguration(state.context));
  //           final bitmap = await android_graphics_Bitmap.create(imageData);
  //           final bitmapDescriptor =
  //               await com_google_android_gms_maps_model_BitmapDescriptorFactory
  //                   .fromBitmap(bitmap);
  //           await locationStyle.myLocationIcon(bitmapDescriptor);
  //         }
  //         // 边框颜色
  //         if (option.strokeColor != null) {
  //           await locationStyle
  //               .strokeColor(Int32List.fromList([option.strokeColor.value])[0]);
  //         }
  //         // 填充颜色
  //         if (option.fillColor != null) {
  //           await locationStyle.radiusFillColor(
  //               Int32List.fromList([option.fillColor.value])[0]);
  //         }
  //         // 边框宽度
  //         if (option.strokeWidth != null) {
  //           await locationStyle.strokeWidth(option.strokeWidth);
  //         }
  //
  //         // 设置样式
  //         await map.setMyLocationStyle(locationStyle);
  //       }
  //
  //       pool..add(map)..add(locationStyle);
  //     },
  //     ios: (pool) async {
  //       await iosController.set_showsUserLocation(option.show);
  //
  //       if (option.show) {
  //         if (option.interval != Duration.zero) {
  //           _locateSubscription?.cancel();
  //           _locateSubscription = Stream.periodic(option.interval, (_) => _)
  //               .listen((_) async =>
  //                   await iosController.setUserTrackingMode_animated(
  //                     MAUserTrackingMode.MAUserTrackingModeFollow,
  //                     true,
  //                   ));
  //         }
  //
  //         switch (option.myLocationType) {
  //           case MyLocationType.Show:
  //             await iosController.setUserTrackingMode_animated(
  //               MAUserTrackingMode.MAUserTrackingModeNone,
  //               true,
  //             );
  //             break;
  //           // ios端没有只定位一次的选项, 所以这里要模拟一下这个效果
  //           // 1. 先设置不跟踪位置, 防止定位marker来回跳
  //           // 2. 获取当前用户位置
  //           // 3. 把当前地图中心点设置为用户位置
  //           case MyLocationType.Locate:
  //             await iosController.setUserTrackingMode_animated(
  //               MAUserTrackingMode.MAUserTrackingModeNone,
  //               true,
  //             );
  //             final myLocation = await iosController.get_userLocation();
  //             await iosController.setCenterCoordinate_animated(
  //               await myLocation.get_coordinate(),
  //               false,
  //             );
  //             break;
  //           case MyLocationType.Follow:
  //             await iosController.setUserTrackingMode_animated(
  //               MAUserTrackingMode.MAUserTrackingModeFollow,
  //               true,
  //             );
  //             break;
  //           case MyLocationType.Rotate:
  //             await iosController.setUserTrackingMode_animated(
  //               MAUserTrackingMode.MAUserTrackingModeFollowWithHeading,
  //               true,
  //             );
  //             break;
  //         }
  //
  //         final style = await MAUserLocationRepresentation.create__();
  //
  //         // 定位图标
  //         if (option.iconProvider != null) {
  //           final imageData = await option.iconProvider
  //               .toImageData(createLocalImageConfiguration(state.context));
  //           final bitmap = await UIImage.create(imageData);
  //           await style.set_image(bitmap);
  //         }
  //         // 边框颜色
  //         if (option.strokeColor != null) {
  //           final color = await UIColor.create(option.strokeColor);
  //           await style.set_strokeColor(color);
  //         }
  //         // 填充颜色
  //         if (option.fillColor != null) {
  //           final color = await UIColor.create(option.fillColor);
  //           await style.set_fillColor(color);
  //         }
  //         // 边框宽度
  //         if (option.strokeWidth != null) {
  //           await style.set_lineWidth(option.strokeWidth);
  //         }
  //
  //         await iosController.updateUserLocationRepresentation(style);
  //       } else {
  //         _locateSubscription?.cancel();
  //       }
  //     },
  //   );
  // }

//   /// 设置我的位置图标旋转角度
//   Future<void> setMyLocationRotateAngle(double angle) async {
//     await platform(
//       android: (pool) async {
//         final map = await androidController.getMap();
//         await map.setMyLocationRotateAngle((360 - angle).abs());
//
//         pool..add(map);
//       },
//       ios: (pool) async {
//         // todo 暂时没有找到比较直接的方式实现
//         print('ios端暂时未实现');
// //        final annotations = await _iosController.get_annotations();
// //        for (final MAAnnotation annotation in annotations) {
// //          if (await annotation.isMAUserLocation()) {
// //            final userLocation = await annotation.asMAUserLocation();
// //            userLocation.set_movingDirection(movingDirection)
// //            break;
// //          }
// //        }
//       },
//     );
//   }

  /// 是否显示室内地图
  @override
  Future<void> showIndoorMap(bool show) async {
    await platform(
      android: (pool) async {
        await (await androidMap).setIndoorEnabled(show);
      },
      ios: (pool) async {
        await iosController.set_indoorEnabled(show);
      },
    );
  }

  /// 选择显示图层
  @override
  Future<void> setMapType(MapType mapType) async {
    await platform(
      android: (pool) async {
        final map = await androidMap;
        switch (mapType) {
          case MapType.Standard:
            await map.setMapType(
                com_google_android_gms_maps_GoogleMap.MAP_TYPE_NORMAL);
            break;
          case MapType.Satellite:
            await map.setMapType(
                com_google_android_gms_maps_GoogleMap.MAP_TYPE_SATELLITE);
            break;
          // TODO 实现剩余的两个类型
          default:
            await map.setMapType(
                com_google_android_gms_maps_GoogleMap.MAP_TYPE_NORMAL);
            break;
          // case MapType.Terrain:
          //   await map.setMapType(
          //       com_google_android_gms_maps_GoogleMap.MAP_TYPE_TERRAIN);
          //   break;
          // case MapType.Hybrid:
          //   await map.setMapType(
          //       com_google_android_gms_maps_GoogleMap.MAP_TYPE_HYBRID);
          //   break;
        }

        pool..add(map);
      },
      ios: (pool) async {
        switch (mapType) {
          case MapType.Standard:
            await iosController.set_mapType(GMSMapViewType.kGMSTypeNormal);
            break;
          case MapType.Satellite:
            await iosController.set_mapType(GMSMapViewType.kGMSTypeSatellite);
            break;
          // TODO 实现剩余的两个类型
          default:
            await iosController.set_mapType(GMSMapViewType.kGMSTypeNormal);
            break;
          // case MapType.Terrain:
          //   await iosController.set_mapType(GMSMapViewType.kGMSTypeTerrain);
          //   break;
          // case MapType.Hybrid:
          //   await iosController.set_mapType(GMSMapViewType.kGMSTypeHybrid);
          //   break;
        }
      },
    );
  }

  /// 显示路况信息
  @override
  Future<void> showTraffic(bool enable) async {
    await platform(
      android: (pool) async {
        await (await androidMap).setTrafficEnabled(enable);
      },
      ios: (pool) async {
        await iosController.set_trafficEnabled(enable);
      },
    );
  }

  /// 显示缩放控件
  @override
  Future<void> showZoomControl(bool enable) async {
    await platform(
      android: (pool) async {
        final uiSetting = await (await androidMap).getUiSettings();
        await uiSetting.setZoomControlsEnabled(enable);

        pool..add(uiSetting);
      },
      ios: (pool) async {
        print('ios端不支持显示缩放控件');
      },
    );
  }

  /// 显示指南针
  @override
  Future<void> showCompass(bool enable) async {
    await platform(
      android: (pool) async {
        final uiSetting = await (await androidMap).getUiSettings();
        await uiSetting.setCompassEnabled(enable);

        pool.add(uiSetting);
      },
      ios: (pool) async {
        final uiSettings = await iosController.get_settings();
        await uiSettings.set_compassButton(enable);
      },
    );
  }

  /// 显示定位按钮
  @override
  Future<void> showLocateControl(bool enable) async {
    await platform(
      android: (pool) async {
        final uiSetting = await (await androidMap).getUiSettings();
        await uiSetting.setMyLocationButtonEnabled(enable);

        pool.add(uiSetting);
      },
      ios: (pool) async {
        final uiSettings = await iosController.get_settings();
        await uiSettings.set_myLocationButton(enable);
      },
    );
  }

  /// 缩放手势使能
  @override
  Future<void> setZoomGesturesEnabled(bool enable) async {
    await platform(
      android: (pool) async {
        final uiSetting = await (await androidMap).getUiSettings();
        await uiSetting.setZoomGesturesEnabled(enable);

        pool.add(uiSetting);
      },
      ios: (pool) async {
        final uiSettings = await iosController.get_settings();
        await uiSettings.set_zoomGestures(enable);
      },
    );
  }

  /// 滑动手势使能
  @override
  Future<void> setScrollGesturesEnabled(bool enable) async {
    await platform(
      android: (pool) async {
        final uiSetting = await (await androidMap).getUiSettings();
        await uiSetting.setScrollGesturesEnabled(enable);

        pool.add(uiSetting);
      },
      ios: (pool) async {
        final uiSettings = await iosController.get_settings();
        await uiSettings.set_scrollGestures(enable);
      },
    );
  }

  /// 旋转手势使能
  @override
  Future<void> setRotateGesturesEnabled(bool enable) async {
    await platform(
      android: (pool) async {
        final uiSetting = await (await androidMap).getUiSettings();
        await uiSetting.setRotateGesturesEnabled(enable);

        pool.add(uiSetting);
      },
      ios: (pool) async {
        final uiSettings = await iosController.get_settings();
        await uiSettings.set_rotateGestures(enable);
      },
    );
  }

  /// 旋转手势使能
  @override
  Future<void> setTiltGesturesEnabled(bool enable) async {
    await platform(
      android: (pool) async {
        final uiSetting = await (await androidMap).getUiSettings();
        await uiSetting.setTiltGesturesEnabled(enable);

        pool.add(uiSetting);
      },
      ios: (pool) async {
        final uiSettings = await iosController.get_settings();
        await uiSettings.set_tiltGestures(enable);
      },
    );
  }

  /// 所有手势使能
  @override
  Future<void> setAllGesturesEnabled(bool enable) async {
    await platform(
      android: (pool) async {
        final uiSetting = await (await androidMap).getUiSettings();
        await uiSetting.setAllGesturesEnabled(enable);

        pool.add(uiSetting);
      },
      ios: (pool) async {
        final uiSettings = await iosController.get_settings();
        await uiSettings.setAllGesturesEnabled(enable);
      },
    );
  }

  /// 设置缩放大小
  ///
  /// 地图的缩放级别一共分为 17 级，从 3 到 19. 数字越大，展示的图面信息越精细
  @override
  Future<void> setZoomLevel(double level, {bool animated = true}) async {
    assert(level >= 3 && level <= 19, '缩放范围为3-19');
    await platform(
      android: (pool) async {
        final cameraUpdate =
            await com_google_android_gms_maps_CameraUpdateFactory.zoomTo(level);
        if (animated) {
          await (await androidMap)
              .animateCamera__com_google_android_gms_maps_CameraUpdate(
                  cameraUpdate);
        } else {
          await (await androidMap).moveCamera(cameraUpdate);
        }

        pool.add(cameraUpdate);
      },
      ios: (pool) async {
        final cameraUpdate = await GMSCameraUpdate.zoomTo(level);
        if (animated) {
          await iosController.animateWithCameraUpdate(cameraUpdate);
        } else {
          await iosController.moveCamera(cameraUpdate);
        }

        pool.add(cameraUpdate);
      },
    );
  }

  /// 获取当前缩放大小
  @override
  Future<double> getZoomLevel() async {
    return platform(
      android: (pool) async {
        final camera = await (await androidMap).getCameraPosition();

        pool.add(camera);
        return camera.get_zoom();
      },
      ios: (pool) async {
        final camera = await iosController.get_camera();

        pool.add(camera);
        return camera.get_zoom();
      },
    );
  }

  /// 放大一个等级
  @override
  Future<void> zoomIn({bool animated = true}) async {
    await platform(
      android: (pool) async {
        final cameraUpdate =
            await com_google_android_gms_maps_CameraUpdateFactory.zoomIn();
        if (animated) {
          await (await androidMap)
              .animateCamera__com_google_android_gms_maps_CameraUpdate(
                  cameraUpdate);
        } else {
          await (await androidMap).moveCamera(cameraUpdate);
        }

        pool.add(cameraUpdate);
      },
      ios: (pool) async {
        final cameraUpdate = await GMSCameraUpdate.zoomIn();
        if (animated) {
          await iosController.animateWithCameraUpdate(cameraUpdate);
        } else {
          await iosController.moveCamera(cameraUpdate);
        }

        pool.add(cameraUpdate);
      },
    );
  }

  /// 缩小一个等级
  @override
  Future<void> zoomOut({bool animated = true}) async {
    await platform(
      android: (pool) async {
        final cameraUpdate =
            await com_google_android_gms_maps_CameraUpdateFactory.zoomOut();
        if (animated) {
          await (await androidMap)
              .animateCamera__com_google_android_gms_maps_CameraUpdate(
                  cameraUpdate);
        } else {
          await (await androidMap).moveCamera(cameraUpdate);
        }

        pool.add(cameraUpdate);
      },
      ios: (pool) async {
        final cameraUpdate = await GMSCameraUpdate.zoomOut();
        if (animated) {
          await iosController.animateWithCameraUpdate(cameraUpdate);
        } else {
          await iosController.moveCamera(cameraUpdate);
        }

        pool.add(cameraUpdate);
      },
    );
  }

  /// 设置地图中心点
  ///
  /// [lat]纬度, [lng]经度, [zoomLevel]缩放等级, [bearing]地图选择角度, [tilt]倾斜角
  @override
  Future<void> setCenterCoordinate(
    LatLng coordinate, {
    double zoomLevel,
    double bearing,
    double tilt,
    bool animated = true,
  }) async {
    assert(
      zoomLevel == null || (zoomLevel >= 3 && zoomLevel <= 19),
      '缩放范围为3-19',
    );
    final lat = coordinate.latitude;
    final lng = coordinate.longitude;
    await platform(
      android: (pool) async {
        final latLng = await com_google_android_gms_maps_model_LatLng
            .create__double__double(lat, lng);

        final camera = await (await androidMap).getCameraPosition();
        final finalZoomLevel = zoomLevel ?? await camera.get_zoom();
        final finalBearing = bearing ?? await camera.get_bearing();
        final finalTilt = tilt ?? await camera.get_tilt();
        final cameraPosition =
            await com_google_android_gms_maps_model_CameraPosition
                .create__com_google_android_gms_maps_model_LatLng__float__float__float(
                    latLng, finalZoomLevel, finalTilt, finalBearing);

        final cameraUpdate =
            await com_google_android_gms_maps_CameraUpdateFactory
                .newCameraPosition(cameraPosition);

        if (animated) {
          await (await androidMap)
              .animateCamera__com_google_android_gms_maps_CameraUpdate(
                  cameraUpdate);
        } else {
          await (await androidMap).moveCamera(cameraUpdate);
        }

        pool..add(latLng)..add(cameraUpdate);
      },
      ios: (pool) async {
        final latLng = await CLLocationCoordinate2D.create(lat, lng);

        final camera = await iosController.get_camera();
        final finalZoomLevel = zoomLevel ?? await camera.get_zoom();
        final finalBearing = bearing ?? await camera.get_bearing();
        final finalTilt = tilt ?? await camera.get_viewingAngle();
        final cameraPosition = await GMSCameraPosition.create__(init: false);
        await cameraPosition.initWithTarget_zoom_bearing_viewingAngle(
            latLng, finalZoomLevel, finalBearing, finalTilt);

        final cameraUpdate = await GMSCameraUpdate.setCamera(cameraPosition);

        if (animated) {
          await iosController.animateWithCameraUpdate(cameraUpdate);
        } else {
          await iosController.moveCamera(cameraUpdate);
        }

        pool..add(latLng)..add(cameraUpdate);
      },
    );
  }

  /// 获取地图中心点
  @override
  Future<LatLng> getCenterCoordinate() {
    return platform(
      android: (pool) async {
        final position = await (await androidMap).getCameraPosition();
        final target = await position.get_target();

        pool..add(position)..add(target);

        return LatLng(
          await target.get_latitude(),
          await target.get_longitude(),
        );
      },
      ios: (pool) async {
        final camera = await iosController.get_camera();
        final target = await camera.get_target();

        return LatLng(await target.latitude, await target.longitude);
      },
    );
  }

  /// 添加marker
  ///
  /// 在纬度[lat], 经度[lng]的位置添加marker, 并设置标题[title]和副标题[snippet], [iconUri]
  /// 可以是图片url, asset路径或者文件路径.
  /// 其中图片参数[imageConfig]如果不知道怎么创建, 那么就直接调用flutter sdk内提供的[createLocalImageConfiguration]方法创建
  @override
  Future<IMarker> addMarker(MarkerOption option) {
    assert(option != null);

    final lat = option.coordinate.latitude;
    final lng = option.coordinate.longitude;
    return platform(
      android: (pool) async {
        // marker经纬度
        final latLng = await com_google_android_gms_maps_model_LatLng
            .create__double__double(lat, lng);

        // marker配置
        final markerOption =
            await com_google_android_gms_maps_model_MarkerOptions.create__();

        // 设置marker经纬度
        await markerOption.position(latLng);
        // 设置marker标题
        if (option.title != null) {
          await markerOption.title(option.title);
        }
        // 设置marker副标题
        if (option.snippet != null) {
          await markerOption.snippet(option.snippet);
        }
        // 设置marker图标
        // 普通图片
        if (option.iconProvider != null) {
          Uint8List iconData = await option.iconProvider
              .toImageData(createLocalImageConfiguration(state.context));

          final bitmap = await android_graphics_Bitmap.create(iconData);
          final icon =
              await com_google_android_gms_maps_model_BitmapDescriptorFactory
                  .fromBitmap(bitmap);
          await markerOption.icon(icon);

          pool..add(bitmap)..add(icon);
        }
        // widget as marker
        else if (option.widget != null) {
          List<Uint8List> iconData =
              await state.widgetToImageData([option.widget]);

          final bitmap = await android_graphics_Bitmap.create(iconData[0]);
          final icon =
              await com_google_android_gms_maps_model_BitmapDescriptorFactory
                  .fromBitmap(bitmap);
          await markerOption.icon(icon);

          pool..add(bitmap)..add(icon);
        }
        // 是否可拖拽
        if (option.draggable != null) {
          await markerOption.draggable(option.draggable);
        }
        // 旋转角度
        if (option.rotateAngle != null) {
          await markerOption.rotation(option.rotateAngle);
        }
        // 锚点 默认在中间底部是最合理的
        await markerOption.anchor(option.anchorU ?? 0.5, option.anchorV ?? 0);
        // 是否可见
        await markerOption.visible(option.visible);

        final marker = await (await androidMap).addMarker(markerOption);

        // 自定义数据
        if (option.object != null) {
          await marker.setTag(option.object);
        }

        // marker不释放, 还有用
        pool..add(latLng)..add(markerOption);

        return Marker.android(marker);
      },
      ios: (pool) async {
        // 创建marker
        final marker = await GMSMarker.create__();

        final coordinate = await CLLocationCoordinate2D.create(lat, lng);

        // 设置经纬度
        await marker.set_position(coordinate);

        // 设置标题
        if (option.title != null) {
          await marker.set_title(option.title);
        }
        // 设置副标题
        if (option.snippet != null) {
          await marker.set_snippet(option.snippet);
        }
        // 设置图片
        // 普通图片
        if (option.iconProvider != null) {
          Uint8List iconData = await option.iconProvider
              .toImageData(createLocalImageConfiguration(state.context));

          final icon = await UIImage.create(iconData);

          // 由于ios端的icon参数在回调中设置, 需要添加属性来实现
          await marker.set_icon(icon);

          pool..add(icon);
        }
        // widget as marker
        else if (option.widget != null) {
          List<Uint8List> iconData =
              await state.widgetToImageData([option.widget]);

          final icon = await UIImage.create(iconData[0]);

          // 由于ios端的icon参数在回调中设置, 需要添加属性来实现
          await marker.set_icon(icon);

          pool..add(icon);
        }
        // 是否可拖拽
        if (option.draggable != null) {
          await marker.set_draggable(option.draggable);
        }
        // 旋转角度
        if (option.rotateAngle != null) {
          await marker.set_rotation(option.rotateAngle);
        }
        // 锚点
        if (option.anchorU != null || option.anchorV != null) {
          await marker.set_groundAnchor(
            await CGPoint.create(option.anchorU, option.anchorV),
          );
        }
        // 自定义数据
        if (option.object != null) {
          await marker.set_userData(option.object);
        }
        // 是否可见
        await marker.set_opacity(option.visible ? 1 : 0);

        await marker.set_map(iosController);

        return Marker.ios(marker);
      },
    );
  }

  /// 批量添加marker
  ///
  /// 根据[options]批量创建Marker
  @override
  Future<List<IMarker>> addMarkers(List<MarkerOption> options) async {
    assert(options != null);

    if (options.isEmpty) return Future.value([]);

    final latBatch = options.map((it) => it.coordinate.latitude).toList();
    final lngBatch = options.map((it) => it.coordinate.longitude).toList();
    final titleBatch = options.map((it) => it.title).toList();
    final snippetBatch = options.map((it) => it.snippet).toList();
    final draggableBatch = options.map((it) => it.draggable).toList();
    final rotateAngleBatch = options.map((it) => it.rotateAngle).toList();
    final anchorUBatch = options.map((it) => it.anchorU).toList();
    final anchorVBatch = options.map((it) => it.anchorV).toList();
    final visibleBatch = options.map((it) => it.visible).toList();
    final objectBatch = options.map((it) => it.object).toList();
    final iconDataBatch = <Uint8List>[
      ...await Future.wait([
        for (final option in options)
          if (option.iconProvider != null)
            option.iconProvider
                .toImageData(createLocalImageConfiguration(state.context))
      ]),
      ...await state.widgetToImageData(options
          .where((element) => element.widget != null)
          .map((e) => e.widget)
          .toList()),
    ];

    return platform(
      android: (pool) async {
        // 获取地图
        final latLngBatch = await com_google_android_gms_maps_model_LatLng
            .create_batch__double__double(latBatch, lngBatch);
        // marker配置
        final markerOptionBatch =
            await com_google_android_gms_maps_model_MarkerOptions
                .create_batch__(options.length);
        // 添加经纬度
        await markerOptionBatch.position_batch(latLngBatch);
        // 添加标题
        await markerOptionBatch.title_batch(titleBatch);
        // 添加副标题
        await markerOptionBatch.snippet_batch(snippetBatch);
        // 是否可拖动
        await markerOptionBatch.draggable_batch(draggableBatch);
        // 旋转角度
        await markerOptionBatch.rotation_batch(rotateAngleBatch);
        // // 锚点
        // await markerOptionBatch.anchor_batch(anchorUBatch, anchorVBatch);
        // 是否可见
        await markerOptionBatch.visible_batch(visibleBatch);
        // 图片
        if (iconDataBatch.isNotEmpty) {
          final bitmapBatch =
              await android_graphics_Bitmap.create_batch(iconDataBatch);
          final iconBatch =
              await com_google_android_gms_maps_model_BitmapDescriptorFactory_Batch
                  .fromBitmap_batch(bitmapBatch);
          await markerOptionBatch.icon_batch(iconBatch);
          pool..addAll(bitmapBatch)..addAll(iconBatch);
        }

        // 添加marker
        final markers =
            await List.filled(markerOptionBatch.length, (await androidMap))
                .addMarker_batch(markerOptionBatch);

        // 自定义数据
        await markers.setTag_batch(objectBatch);

        // marker不释放, 还有用
        pool..addAll(latLngBatch)..addAll(markerOptionBatch);
        return markers.map((it) => Marker.android(it)).toList();
      },
      ios: (pool) async {
        // 创建marker
        final markerBatch = await GMSMarker.create_batch__(options.length);

        // 经纬度列表
        final coordinateBatch =
            await CLLocationCoordinate2D.create_batch(latBatch, lngBatch);
        // 设置经纬度
        await markerBatch.set_position_batch(coordinateBatch);
        // 设置标题
        await markerBatch.set_title_batch(titleBatch);
        // 设置副标题
        await markerBatch.set_snippet_batch(snippetBatch);
        // 设置图片
        if (iconDataBatch.isNotEmpty) {
          final iconBatch = await UIImage.create_batch(iconDataBatch);
          await markerBatch.set_icon_batch(iconBatch);
          pool.addAll(iconBatch);
        }
        // 是否可拖拽
        await markerBatch.set_draggable_batch(draggableBatch);
        // 旋转角度
        await markerBatch.set_rotation_batch(rotateAngleBatch);
        // // 锚点
        // await markerBatch.set_groundAnchor_batch(
        //     await CGPoint.create_batch(anchorUBatch, anchorVBatch));
        // 自定义数据
        await markerBatch.set_userData_batch(objectBatch);
        // 是否可见
        await markerBatch
            .set_opacity_batch(visibleBatch.map((e) => e ? 1.0 : 0.0).toList());

        // 添加marker
        await markerBatch
            .set_map_batch(List.filled(options.length, iosController));

        return [
          for (int i = 0; i < options.length; i++) Marker.ios(markerBatch[i])
        ];
      },
    );
  }

  //
  // /// 把marker列表从地图上移除
  // Future<void> clearMarkers(List<IMarker> markers) async {
  //   await platform(
  //     android: (pool) async {
  //       final markerBatch = markers.map((it) => it.androidModel).toList();
  //       await markerBatch.remove_batch();
  //     },
  //     ios: (pool) async {
  //       final markerBatch = markers.map((it) => it.iosModel).toList();
  //       await markerBatch.set_map_batch(null);
  //     },
  //   );
  // }
  //
  /// 清除地图上所有覆盖物
  ///
  /// 根据[keepMyLocation]区分是否保留我的位置的marker
  @override
  Future<void> clear({bool keepMyLocation = true}) async {
    await platform(
      android: (pool) async {
        await (await androidMap).clear();
      },
      ios: (pool) async {
        await iosController.clear();
      },
    );
  }

  /// 屏幕坐标转经纬度坐标
  @override
  Future<LatLng> fromScreenLocation(Point point) async {
    return platform(
      android: (pool) async {
        final projection = await (await androidMap).getProjection();

        final androidPoint = await android_graphics_Point.create(
            point.x.toInt(), point.y.toInt());

        final latLng = await projection.fromScreenLocation(androidPoint);

        pool..add(projection)..add(androidPoint)..add(latLng);
        return LatLng(
            await latLng.get_latitude(), await latLng.get_longitude());
      },
      ios: (pool) async {
        final projection = await iosController.get_projection();

        final iosPoint = await CGPoint.create(point.x, point.y);

        final latLng = await projection.coordinateForPoint(iosPoint);

        pool..add(projection)..add(iosPoint)..add(latLng);
        return LatLng(await latLng.latitude, await latLng.longitude);
      },
    );
  }

  /// 经纬度坐标转屏幕坐标
  @override
  Future<Point> toScreenLocation(LatLng coordinate) async {
    return platform(
      android: (pool) async {
        final projection = await (await androidMap).getProjection();

        final latLng = await com_google_android_gms_maps_model_LatLng
            .create__double__double(coordinate.latitude, coordinate.longitude);

        final point = await projection.toScreenLocation(latLng);

        pool..add(projection)..add(latLng)..add(point);
        return Point((await point.x).toDouble(), (await point.y).toDouble());
      },
      ios: (pool) async {
        final projection = await iosController.get_projection();

        final latLng = await CLLocationCoordinate2D.create(
            coordinate.latitude, coordinate.longitude);

        final point = await projection.pointForCoordinate(latLng);

        pool..add(projection)..add(latLng)..add(point);
        return Point((await point.x).toDouble(), (await point.y).toDouble());
      },
    );
  }

  /// 添加折线
  ///
  /// 可配置参数详见[PolylineOption]
  @override
  Future<IPolyline> addPolyline(PolylineOption option) async {
    assert(option != null);

    final latitudeBatch = option.coordinateList.map((e) => e.latitude).toList();
    final longitudeBatch =
        option.coordinateList.map((e) => e.longitude).toList();
    final textureData = await option.textureProvider
        ?.toImageData(createLocalImageConfiguration(state.context));
    return platform(
      android: (pool) async {
        // 构造折线点
        List<com_google_android_gms_maps_model_LatLng> latLngList =
            await com_google_android_gms_maps_model_LatLng
                .create_batch__double__double(
          latitudeBatch,
          longitudeBatch,
        );

        // 构造折线参数
        final polylineOptions =
            await com_google_android_gms_maps_model_PolylineOptions.create__();

        // 添加经纬度列表
        await polylineOptions.addAll(latLngList);
        if (option.width != null) {
          await polylineOptions.width(option.width);
        }
        // 颜色
        if (option.strokeColor != null) {
          await polylineOptions
              .color(Int32List.fromList([option.strokeColor.value])[0]);
        }
        // // 自定义贴图
        // if (textureData != null) {
        //   final bitmap = await android_graphics_Bitmap.create(textureData);
        //   final texture =
        //       await com_google_android_gms_maps_model_BitmapDescriptorFactory
        //           .fromBitmap(bitmap);
        //   await polylineOptions.setCustomTexture(texture);
        //   await polylineOptions.setUseTexture(true);
        //
        //   pool..add(bitmap)..add(texture);
        // }
        // // 线段始末端样式, 由于两端的枚举顺序是一样的, 所以这里直接从索引获取枚举
        // if (option.lineCapType != null) {
        //   await polylineOptions.startCap(
        //     com_amap_api_maps_model_PolylineOptions_LineCapType
        //         .values[option.lineCapType.index],
        //   );
        // }
        // // 线段连接处样式, 由于两端的枚举顺序是一样的, 所以这里直接从索引获取枚举
        // if (option.lineJoinType != null) {
        //   await polylineOptions.lineJoinType(
        //       com_amap_api_maps_model_PolylineOptions_LineJoinType
        //           .values[option.lineJoinType.index]);
        // }
        // // 是否虚线
        // if (option.dashType != null) {
        //   await polylineOptions.setDottedLine(true);
        //   switch (option.dashType) {
        //     case DashType.Square:
        //       await polylineOptions.setDottedLineType(
        //           com_amap_api_maps_model_PolylineOptions
        //               .DOTTEDLINE_TYPE_SQUARE);
        //       break;
        //     case DashType.Circle:
        //       await polylineOptions.setDottedLineType(
        //           com_amap_api_maps_model_PolylineOptions
        //               .DOTTEDLINE_TYPE_CIRCLE);
        //       break;
        //   }
        // }
        // 设置参数
        final polyline = await (await androidMap).addPolyline(polylineOptions);

        pool
          ..add(polylineOptions)
          ..addAll(latLngList);

        return Polyline.android(polyline);
      },
      ios: (pool) async {
        // 构造折线点
        List<CLLocationCoordinate2D> latLngList =
            await CLLocationCoordinate2D.create_batch(
                latitudeBatch, longitudeBatch);

        // 构造折线参数
        final path = await GMSMutablePath.create__();
        await List.filled(latLngList.length, path)
            .addCoordinate_batch(latLngList);
        final polyline = await GMSPolyline.polylineWithPath(path);

        if (option.width != null) {
          await polyline.set_strokeWidth(
              option.width / MediaQuery.of(state.context).devicePixelRatio);
        }
        // 颜色
        if (option.strokeColor != null) {
          await polyline
              .set_strokeColor(await UIColor.create(option.strokeColor));
        }
        // // 设置图片
        // if (textureData != null) {
        //   final texture = await UIImage.create(textureData);
        //
        //   polyline.addProperty__(3, texture);
        //
        //   pool..add(texture);
        // }
        // // 线段始末端样式, 由于两端的枚举顺序是一样的, 所以这里直接从索引获取枚举
        // if (option.lineCapType != null) {
        //   polyline.addJsonableProperty__(4, option.lineCapType.index);
        // }
        // // 线段连接处样式, 由于两端的枚举顺序是一样的, 所以这里直接从索引获取枚举
        // if (option.lineJoinType != null) {
        //   polyline.addJsonableProperty__(5, option.lineJoinType.index);
        // }
        // // 是否虚线
        // if (option.dashType != null) {
        //   polyline.addJsonableProperty__(6, option.dashType.index + 1);
        // }

        // 设置参数
        await polyline.set_map(iosController);

        pool..addAll(latLngList);

        return Polyline.ios(polyline);
      },
    );
  }

  /// 添加多边形
  ///
  /// 在点[points]的位置添加线, 可以设置宽度[width]和颜色[strokeColor]
  @override
  Future<IPolygon> addPolygon(PolygonOption option) {
    assert(option != null, 'option不能为null');

    final latitudeBatch = option.coordinateList.map((e) => e.latitude).toList();
    final longitudeBatch =
        option.coordinateList.map((e) => e.longitude).toList();

    return platform(
      android: (pool) async {
        // 构造折线点
        List<com_google_android_gms_maps_model_LatLng> latLngList =
            await com_google_android_gms_maps_model_LatLng
                .create_batch__double__double(
          latitudeBatch,
          longitudeBatch,
        );

        // 构造参数
        final polygonOptions =
            await com_google_android_gms_maps_model_PolygonOptions.create__();

        // 添加参数
        await polygonOptions.addAll(latLngList);
        // 宽度
        if (option.width != null) {
          await polygonOptions.strokeWidth(option.width);
        }
        // 边框颜色
        if (option.strokeColor != null) {
          await polygonOptions
              .strokeColor(Int32List.fromList([option.strokeColor.value])[0]);
        }
        // 填充颜色
        if (option.fillColor != null) {
          await polygonOptions
              .fillColor(Int32List.fromList([option.fillColor.value])[0]);
        }

        // 设置参数
        final polygon = await (await androidMap).addPolygon(polygonOptions);

        pool
          ..add(polygonOptions)
          ..addAll(latLngList);

        return Polygon.android(polygon);
      },
      ios: (pool) async {
        // 构造折线点
        List<CLLocationCoordinate2D> latLngList =
            await CLLocationCoordinate2D.create_batch(
                latitudeBatch, longitudeBatch);

        // 构造折线参数
        final path = await GMSMutablePath.create__();
        await List.filled(latLngList.length, path)
            .addCoordinate_batch(latLngList);
        final polygon = await GMSPolygon.polygonWithPath(path);

        if (option.width != null) {
          await polygon.set_strokeWidth(
              option.width / MediaQuery.of(state.context).devicePixelRatio);
        }
        if (option.strokeColor != null) {
          await polygon
              .set_strokeColor(await UIColor.create(option.strokeColor));
        }
        if (option.fillColor != null) {
          await polygon.set_fillColor(await UIColor.create(option.fillColor));
        }

        // 设置参数
        await polygon.set_map(iosController);

        pool.addAll(latLngList);

        return Polygon.ios(polygon);
      },
    );
  }

  /// 添加圆
  ///
  /// 在点[points]的位置添加线, 可以设置宽度[width]和颜色[strokeColor]
  @override
  Future<ICircle> addCircle(CircleOption option) {
    return platform(
      android: (pool) async {
        // 构造点
        final latLng = await com_google_android_gms_maps_model_LatLng
            .create__double__double(
          option.center.latitude,
          option.center.longitude,
        );

        // 构造参数
        final circleOptions =
            await com_google_android_gms_maps_model_CircleOptions.create__();

        // 中心点
        await circleOptions.center(latLng);
        // 半径
        await circleOptions.radius(option.radius);
        // 宽度
        if (option.width != null) {
          await circleOptions.strokeWidth(option.width);
        }
        // 边框颜色
        if (option.strokeColor != null) {
          await circleOptions
              .strokeColor(Int32List.fromList([option.strokeColor.value])[0]);
        }
        // 填充颜色
        if (option.fillColor != null) {
          await circleOptions
              .fillColor(Int32List.fromList([option.fillColor.value])[0]);
        }

        // 设置参数
        final circle = await (await androidMap).addCircle(circleOptions);

        pool..add(circleOptions)..add(latLng);

        return Circle.android(circle);
      },
      ios: (pool) async {
        final latLng = await CLLocationCoordinate2D.create(
          option.center.latitude,
          option.center.longitude,
        );

        // 参数
        final circle =
            await GMSCircle.circleWithPosition_radius(latLng, option.radius);

        if (option.width != null) {
          await circle.set_strokeWidth(option.width);
        }
        if (option.strokeColor != null) {
          await circle
              .set_strokeColor(await UIColor.create(option.strokeColor));
        }
        if (option.fillColor != null) {
          await circle.set_fillColor(await UIColor.create(option.fillColor));
        }

        // 设置参数
        await circle.set_map(iosController);

        return Circle.ios(circle);
      },
    );
  }

  /// 设置marker点击监听事件
  @override
  Future<void> setMarkerClickedListener(OnMarkerClicked onMarkerClicked) async {
    await platform(
      android: (pool) async {
        await (await androidMap).setOnMarkerClickListener(
            androidMapDelegate.._onMarkerClicked = onMarkerClicked);
      },
      ios: (pool) async {
        await iosController
            .set_delegate(iosMapDelegate.._onMarkerClicked = onMarkerClicked);
      },
    );
  }
  //
  // /// 设置marker拖动监听事件
  // Future<void> setMarkerDragListener({
  //   OnMarkerDrag onMarkerDragStart,
  //   OnMarkerDrag onMarkerDragging,
  //   OnMarkerDrag onMarkerDragEnd,
  // }) async {
  //   await platform(
  //     android: (pool) async {
  //       final map = await androidController.getMap();
  //
  //       await map.setOnMarkerDragListener(
  //         androidMapDelegate
  //           ..onMarkerDragStarted = onMarkerDragStart
  //           ..onMarkerDragging = onMarkerDragging
  //           ..onMarkerDragEnded = onMarkerDragEnd,
  //       );
  //
  //       pool..add(map);
  //     },
  //     ios: (pool) async {
  //       await iosController.set_delegate(
  //         iosMapDelegate
  //           ..onMarkerDragStarted = onMarkerDragStart
  //           ..onMarkerDragging = onMarkerDragging
  //           ..onMarkerDragEnded = onMarkerDragEnd,
  //       );
  //     },
  //   );
  // }
  //
  // /// 设置地图点击监听事件
  // Future<void> setMapClickedListener(OnMapClicked onMapClick) async {
  //   await platform(
  //     android: (pool) async {
  //       final map = await androidController.getMap();
  //
  //       await map.setOnMapClickListener(
  //         androidMapDelegate..onMapClicked = onMapClick,
  //       );
  //
  //       pool..add(map);
  //     },
  //     ios: (pool) async {
  //       await iosController.set_delegate(
  //         iosMapDelegate..onMapClicked = onMapClick,
  //       );
  //     },
  //   );
  // }
  //
  // /// 设置地图长按监听事件
  // Future<void> setMapLongPressedListener(OnMapClicked onMapLongPress) async {
  //   await platform(
  //     android: (pool) async {
  //       final map = await androidController.getMap();
  //
  //       await map.setOnMapLongClickListener(
  //         androidMapDelegate..onMapLongClicked = onMapLongPress,
  //       );
  //
  //       pool..add(map);
  //     },
  //     ios: (pool) async {
  //       await iosController.set_delegate(
  //         iosMapDelegate..onMapLongClicked = onMapLongPress,
  //       );
  //     },
  //   );
  // }
  //
  // /// 设置地图移动监听事件
  // Future<void> setMapMoveListener({
  //   OnMapMove onMapMoveStart,
  //   OnMapMove onMapMoving,
  //   OnMapMove onMapMoveEnd,
  // }) async {
  //   await platform(
  //     android: (pool) async {
  //       final map = await androidController.getMap();
  //
  //       await map.setOnCameraChangeListener(
  //         androidMapDelegate
  //           ..onMapMoveStart = onMapMoveStart
  //           ..onMapMoving = onMapMoving
  //           ..onMapMoveEnd = onMapMoveEnd,
  //       );
  //
  //       pool..add(map);
  //     },
  //     ios: (pool) async {
  //       await iosController.set_delegate(
  //         iosMapDelegate
  //           ..onMapMoveStart = onMapMoveStart
  //           ..onMapMoving = onMapMoving
  //           ..onMapMoveEnd = onMapMoveEnd,
  //       );
  //     },
  //   );
  // }
  //
  // /// 设置地图移动监听事件
  // ///
  // /// !还有bug, 建议先使用*amap_location_fluttify*代替
  // Future<void> setMyLocationChangeListener(
  //   OnLocationChange onLocationChange,
  // ) async {
  //   await platform(
  //     android: (pool) async {
  //       final map = await androidController.getMap();
  //
  //       await map.setOnMyLocationChangeListener(
  //         androidMapDelegate..onLocationChange = onLocationChange,
  //       );
  //
  //       pool..add(map);
  //     },
  //     ios: (pool) async {
  //       await iosController.set_delegate(
  //         iosMapDelegate..onLocationChange = onLocationChange,
  //       );
  //     },
  //   );
  // }
  //
  // /// 请求后台定位 *仅iOS
  // Future<void> requireAlwaysAuth() async {
  //   await platform(
  //     android: (pool) async {},
  //     ios: (pool) async {
  //       final onRequireAuth = (CLLocationManager manager) async {
  //         await manager?.requestAlwaysAuthorization();
  //       };
  //       await iosController.set_delegate(
  //         iosMapDelegate..onRequireAlwaysAuth = onRequireAuth,
  //       );
  //     },
  //   );
  // }
  //
  // /// 截图
  // Future<void> screenShot(OnScreenShot onScreenShot) async {
  //   assert(onScreenShot != null);
  //   await platform(
  //     android: (pool) async {
  //       final map = await androidController.getMap();
  //       await map.getMapScreenShot(
  //         androidMapDelegate..onSnapshot = onScreenShot,
  //       );
  //
  //       pool.add(map);
  //     },
  //     ios: (pool) async {
  //       final rect = await iosController.frame;
  //       await iosController.takeSnapshotInRect_withCompletionBlock(
  //         rect,
  //         (image, state) async {
  //           await onScreenShot(await image.data);
  //           pool.add(image);
  //         },
  //       );
  //
  //       pool.add(rect);
  //     },
  //   );
  // }
  //
  // /// 限制地图的显示范围
  // ///
  // /// [southWest]西南角, [northEast]东北角
  // Future<void> setMapRegionLimits(LatLng southWest, LatLng northEast) async {
  //   await platform(
  //     android: (pool) async {
  //       final map = await androidController.getMap();
  //
  //       final southWestPoint = await com_google_android_gms_maps_model_LatLng
  //           .create__double__double(southWest.latitude, southWest.longitude);
  //       final northEastPoint = await com_google_android_gms_maps_model_LatLng
  //           .create__double__double(northEast.latitude, northEast.longitude);
  //
  //       final latLngBounds = await com_google_android_gms_maps_model_LatLngBounds
  //           .create__com_google_android_gms_maps_model_LatLng__com_google_android_gms_maps_model_LatLng(
  //               southWestPoint, northEastPoint);
  //
  //       await map.setMapStatusLimits(latLngBounds);
  //
  //       pool
  //         ..add(map)
  //         ..add(southWestPoint)
  //         ..add(northEastPoint)
  //         ..add(latLngBounds);
  //     },
  //     ios: (pool) async {
  //       final center = await CLLocationCoordinate2D.create(
  //         (southWest.latitude + northEast.latitude) / 2,
  //         (southWest.longitude + northEast.longitude) / 2,
  //       );
  //       final span = await MACoordinateSpanMake(
  //         northEast.latitude - southWest.latitude,
  //         northEast.longitude - southWest.longitude,
  //       );
  //       final region = await MACoordinateRegionMake(center, span);
  //       iosController.set_limitRegion(region);
  //
  //       pool..add(center)..add(span)..add(region);
  //     },
  //   );
  // }
  //
  // /// Marker弹窗点击事件监听
  // Future<void> setInfoWindowClickListener(
  //   OnMarkerClicked onInfoWindowClicked,
  // ) async {
  //   await platform(
  //     android: (pool) async {
  //       final map = await androidController.getMap();
  //
  //       await map.setOnInfoWindowClickListener(
  //         androidMapDelegate..onInfoWindowClicked = onInfoWindowClicked,
  //       );
  //       pool.add(map);
  //     },
  //     ios: (pool) async {
  //       await iosController.set_delegate(
  //         iosMapDelegate..onInfoWindowClicked = onInfoWindowClicked,
  //       );
  //     },
  //   );
  // }
}
