import 'package:core_location_fluttify/core_location_fluttify.dart';
import 'package:flutter/cupertino.dart';
import 'package:flutter/foundation.dart';
import 'package:google_map_fluttify/google_map_fluttify.dart';
import 'package:google_map_fluttify/src/android/android.export.g.dart';
import 'package:google_map_fluttify/src/ios/ios.export.g.dart';

/// 除了地图以外的功能放在这里, 比如说sdk初始化
class GoogleMapService implements IMapService {
  static GoogleMapService instance = GoogleMapService._();

  GoogleMapService._();

  /// 设置ios和android的app key
  @override
  Future<void> init({@required String iosKey, String androidKey}) async {
    await platform(
      android: (pool) async {
        final context = await android_app_Application.get();
        await com_google_android_gms_maps_MapsInitializer.initialize(context);

        pool.add(context);
      },
      ios: (pool) async {
        await GMSServices.provideAPIKey(iosKey);
      },
    );
  }
}
