// ignore_for_file: non_constant_identifier_names
part of 'google_map_view.widget.dart';

class _IOSMapDelegate extends NSObject with _Callbacks, GMSMapViewDelegate {
  GMSMapView iosController;

  @override
  Future<bool> mapView_didTapMarker(
    GMSMapView mapView,
    GMSMarker marker,
  ) async {
    if (_onMarkerClicked != null) {
      await _onMarkerClicked(Marker.ios(marker));
    }
    return true;
  }
}

class _AndroidMapDelegate extends java_lang_Object
    with
        _Callbacks,
        com_google_android_gms_maps_GoogleMap_OnMarkerClickListener,
        com_google_android_gms_maps_GoogleMap_SnapshotReadyCallback {
  @override
  Future<bool> onMarkerClick(
    com_google_android_gms_maps_model_Marker var1,
  ) async {
    await _onMarkerClicked?.call(Marker.android(var1));
    return true;
  }

  @override
  Future<void> onSnapshotReady(android_graphics_Bitmap var1) async {
    _onSnapshot?.call(var1);
  }
}

mixin _Callbacks {
  OnMarkerClicked _onMarkerClicked;
  void Function(android_graphics_Bitmap image) _onSnapshot;
}
